void IRtrackobject()
{
  //========================================================= track object with left eye ============================================
  int panscale;           
  int tiltscale;
  int panadjust;
  int tiltadjust;

  if (Ldistance<maxdistance)                               // if no object in range of left eye
  {
    if(Rdistance<maxdistance)                              // if no object in range then scan left eye
    {
      LeyeScan();
    }
    else                                                   // if object in range of right eye then turn right
    {                          
      if (svp[24]>Lpanc+500)svp[24]-=5;                    // pan left eye to the right
      if (svp[24]<Lpanc+500)svp[24]+=5;                    // pan left eye to the right
      if (svp[25]>svp[27])svp[25]-=5;                      // match left tilt with right tilt
      if (svp[25]<svp[27])svp[25]+=5;                      // match left tilt with right tilt
    }
  }
  else
  {
    //------------------------------------------------------- Track object ------------------------------------------------
    panscale=(LLIRvalue+LRIRvalue)/panscalefactor;         // calculate panscale according to distance
    panadjust=(LLIRvalue-LRIRvalue)*5/panscale;            // calculate amount to adjust pan servo by
    svp[24]-=panadjust;

    if (panadjust>5) track+=panadjust;                     // track value used to determine level of visual stimulation

    tiltscale=(LUIRvalue+LDIRvalue)/tiltscalefactor;       // calculate tiltscale according to distance  
    tiltadjust=(LUIRvalue-LDIRvalue)*5/tiltscale;          // calculate amount to adjust tilt servo by
    svp[25]-=tiltadjust;

    if (tiltadjust>5) track+=tiltadjust;                   // track value used to determine level of visual stimulation

    if(svp[24]<Lpanmin) svp[24]=Lpanmin;                   // prevent servos exceeding limit
    if(svp[24]>Lpanmax) svp[24]=Lpanmax;
    if(svp[25]<Ltiltmin) svp[25]=Ltiltmin;
    if(svp[25]>Ltiltmax) svp[25]=Ltiltmax;
  }
  sv[24].writeMicroseconds(svc[24]-svp[24]+svc[24]);       // update left eye pan/tilt servos
  sv[25].writeMicroseconds(svc[25]-svp[25]+svc[25]);
  
  //sv[24].writeMicroseconds(svp[24]);                     // this code for servos that rotate in the opposite direction.
  //sv[25].writeMicroseconds(svp[25]);

  //========================================================= track object with right eye ============================================

  if (Rdistance<maxdistance)                               // if no object in range of right eye
  {
    if (Ldistance<maxdistance)                             // if no object in range then scan right eye
    {
      ReyeScan();
    }
    else                                                   // if object in range of Left eye then turn left
    {
      if (svp[26]>Rpanc+500)svp[26]-=5;                    // pan right ey to the left
      if (svp[26]<Rpanc+500)svp[26]+=5;                    // pan right ey to the left
      if (svp[27]>svp[25])svp[27]-=5;                      // match right tilt with left tilt
      if (svp[27]<svp[25])svp[27]+=5;                      // match right tilt with left tilt
    }
  }
  else
  {
    //------------------------------------------------------- Track object ------------------------------------------------
    panscale=(RLIRvalue+RRIRvalue)/panscalefactor;      
    panadjust=(RLIRvalue-RRIRvalue)*5/panscale;
    svp[26]-=panadjust;

    if (panadjust>5) track+=panadjust;                     // track value used to determine level of visual stimulation

    tiltscale=(RUIRvalue+RDIRvalue)/tiltscalefactor;      
    tiltadjust=(RUIRvalue-RDIRvalue)*5/tiltscale;
    svp[27]-=tiltadjust;

    if (tiltadjust>5) track+=tiltadjust;                   // track value used to determine level of visual stimulation

    if(svp[26]<Rpanmin) svp[26]=Rpanmin;                   // prevent servos exceeding limit
    if(svp[26]>Rpanmax) svp[26]=Rpanmax;
    if(svp[27]<Ltiltmin) svp[27]=Rtiltmin;
    if(svp[27]>Ltiltmax) svp[27]=Rtiltmax;
  } 
  
  sv[26].writeMicroseconds(svc[26]-svp[26]+svc[26]);       // update right eye pan/tilt servos
  sv[27].writeMicroseconds(svc[27]-svp[27]+svc[27]);       
  
  //sv[26].writeMicroseconds(svp[26]);                     // this code for servos that rotate in the opposite direction.
  //sv[27].writeMicroseconds(svp[27]);
}


void LeyeScan()
{
  svp[24]+=lp;                                             // adjust left eye pan position
  if (svp[24]<Lpanmin || svp[24]>Lpanmax) lp*=-1;          // if servo tries to exceed limits then reverse direction
  svp[25]+=lt;                                             // adjust left eye pan position
  if (svp[25]<Ltiltmin || svp[25]>Ltiltmax) lt*=-1;        // if servo tries to exceed limits then reverse direction

  sv[24].writeMicroseconds(svp[24]);                       // update the servos position
  sv[25].writeMicroseconds(svp[25]);                       // update the servos position
}


void ReyeScan()
{
  svp[26]+=rp;                                             // adjust right eye pan psition
  if (svp[26]<Rpanmin || svp[26]>Rpanmax) rp*=-1;          // if servo tries to exceed limits then reverse direction
  svp[27]+=rt;                                             // adjust right eye pan psition
  if (svp[27]<Rtiltmin || svp[27]>Rtiltmax) rt*=-1;        // if servo tries to exceed limits then reverse direction

  sv[26].writeMicroseconds(svp[26]);                       // update the servos position
  sv[27].writeMicroseconds(svp[27]);                       // update the servos position
}

