//=========================================================== Cycle through 8 legged walk sequence ==================================
void Walk1()
{
  lift=-500;
  stride++;                                                // cycle through gait sequence
  if (stride>23)
  {
    stride=0;                                              // restart stride sequence
    if (OLspeed>Lspeed) OLspeed--;                         // limit rate of Lspeed change to prevent leg tanglement 
    if (OLspeed<Lspeed) OLspeed++;
    if (ORspeed>Rspeed) ORspeed--;                         // limit rate of Rspeed change to prevent leg tanglement 
    if (ORspeed<Rspeed) ORspeed++;
    if (OCspeed>Cspeed) OCspeed--;                         // limit rate of Cspeed change to prevent leg tanglement 
    if (OCspeed<Cspeed) OCspeed++;
  }

  for(int i=0;i<4;i++)                                     // keep knees and hips moving
  {
    svp[i+4]-=OCspeed*4;                                   // move left  knees allowing for speed and direction
    svp[i+16]-=OCspeed*4;                                  // move right knees allowing for speed and direction
    svp[i+8]+=OLspeed*4;                                   // move left  hips allowing for speed and direction
    svp[i+12]-=ORspeed*4;                                  // move right hips allowing for speed and direction
  }

  switch(stride)
  {
  case 0:
    svp[3]=svc[3+pos]+lift;                                // lift leg1
    svp[1]=svc[1+pos]+lift;                                // lift leg3
    svp[23]=svc[23+pos]-lift;                              // lift leg5
    svp[21]=svc[21+pos]-lift;                              // lift leg7
    break;

  case 1:
    svp[11]=svc[11+pos]-(OLspeed*48);                      // move leg1 forward
    svp[9]=svc[9+pos]-(OLspeed*48);                        // move leg3 forward
    svp[15]=svc[15+pos]+(ORspeed*48);                      // move leg5 forward
    svp[13]=svc[13+pos]+(ORspeed*48);                      // move leg7 forward

    svp[7]=svc[7+pos]+(OCspeed*48);                        // extend/retract knee1
    svp[5]=svc[5+pos]+(OCspeed*48);                        // extend/retract knee3
    svp[19]=svc[19+pos]+(OCspeed*48);                      // extend/retract knee5
    svp[17]=svc[17+pos]+(OCspeed*48);                      // extend/retract knee7
    break;
    
  case 4:
    svp[3]=svc[3+pos]+100;                                     // lower leg1
    svp[1]=svc[1+pos]+100;                                     // lower leg3
    svp[23]=svc[23+pos]-100;                                   // lower leg5
    svp[21]=svc[21+pos]-100;                                   // lower leg7
    break;
    
  case 5:
    svp[3]=svc[3+pos]+50;                                     // lower leg1
    svp[1]=svc[1+pos]+50;                                     // lower leg3
    svp[23]=svc[23+pos]-50;                                   // lower leg5
    svp[21]=svc[21+pos]-50;                                   // lower leg7
    break;
    
  case 6:
    svp[3]=svc[3+pos];                                     // lower leg1
    svp[1]=svc[1+pos];                                     // lower leg3
    svp[23]=svc[23+pos];                                   // lower leg5
    svp[21]=svc[21+pos];                                   // lower leg7
    break;

  case 12:
    svp[2]=svc[2+pos]+lift;                                // lift leg2
    svp[0]=svc[0+pos]+lift;                                // lift leg4
    svp[22]=svc[22+pos]-lift;                              // lift leg6
    svp[20]=svc[20+pos]-lift;                              // lift leg8
    break;

  case 13:
    if (OLspeed>Lspeed) OLspeed--;                         // limit rate of Lspeed change to prevent leg tanglement 
    if (OLspeed<Lspeed) OLspeed++;
    if (ORspeed>Rspeed) ORspeed--;                         // limit rate of Rspeed change to prevent leg tanglement 
    if (ORspeed<Rspeed) ORspeed++;
    if (OCspeed>Cspeed) OCspeed--;                         // limit rate of Cspeed change to prevent leg tanglement 
    if (OCspeed<Cspeed) OCspeed++;

    svp[10]=svc[10+pos]-(OLspeed*48);                      // move leg2 forward
    svp[8]=svc[8+pos]-(OLspeed*48);                        // move leg4 forward
    svp[14]=svc[14+pos]+(ORspeed*48);                      // move leg6 forward
    svp[12]=svc[12+pos]+(ORspeed*48);                      // move leg8 forward

    svp[6]=svc[6+pos]+(OCspeed*48);                        // extend/retract knee2
    svp[4]=svc[4+pos]+(OCspeed*48);                        // extend/retract knee4
    svp[18]=svc[18+pos]+(OCspeed*48);                      // extend/retract knee6
    svp[16]=svc[16+pos]+(OCspeed*48);                      // extend/retract knee8
    break;
  
  case 16:
    svp[2]=svc[2+pos]+100;                                     // lower leg2
    svp[0]=svc[0+pos]+100;                                     // lower leg4
    svp[22]=svc[22+pos]-100;                                   // lower leg6
    svp[20]=svc[20+pos]-100;                                   // lower leg8
    break;
    
  case 17:
    svp[2]=svc[2+pos]+50;                                     // lower leg2
    svp[0]=svc[0+pos]+50;                                     // lower leg4
    svp[22]=svc[22+pos]-50;                                   // lower leg6
    svp[20]=svc[20+pos]-50;                                   // lower leg8
    break;
    
  case 18:
    svp[2]=svc[2+pos];                                     // lower leg2
    svp[0]=svc[0+pos];                                     // lower leg4
    svp[22]=svc[22+pos];                                   // lower leg6
    svp[20]=svc[20+pos];                                   // lower leg8
    break;
  }
  ServoUpdate();
}
